//+------------------------------------------------------------------+
//|                                                          VSI.mq5 |
//|                                      Copyright  2005, DriverDan |
//|                                        superfunman2000@yahoo.com | 
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2005, DriverDan"
//----    
#property link "superfunman2000@yahoo.com"

#property description "Indicator that calculates volume per second (or period) and the corresponding MA."
#property description "Uses volume per second since it will be uniform for all chart periods."
#property description "Indicator seems to work best on 15m to 4h charts. IMHO, 1m and 5m periods are"
#property description "too short for valid results and 1d+ will show low periods for partial days on MT4."
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----        
#property indicator_buffers 2
//----    
#property indicator_plots   2
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----       Magenta 
#property indicator_color1   clrMagenta
//----   1 - 
#property indicator_style1  STYLE_DASHDOTDOT
//----    1  1
#property indicator_width1  1
//----    
#property indicator_label1  "VSI"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----        
#property indicator_color2  clrBlue
//----   2 -  
#property indicator_style2  STYLE_SOLID
//----    2  1
#property indicator_width2  1
//----    
#property indicator_label2  "Signal VSI"
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input ENUM_APPLIED_VOLUME VolumeType=VOLUME_TICK;  //
input Smooth_Method XMA_Method=MODE_EMA; // 
input int XLength=5; //                     
input int XPhase=15; // ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input bool showPerPeriod=false;  //showPerPeriod (false = volume per second, true = volume per chart period)
input int Shift=0; //       
//+----------------------------------------------+
//----   ,    
//      
double VSIBuffer[],SignBuffer[];
//----      
int min_rates_total,PSec;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=XMA.GetStartBars(XMA_Method,XLength,XPhase)+1;
   PSec=PeriodSeconds(PERIOD_CURRENT);

//----    SignBuffer   
   SetIndexBuffer(0,VSIBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1  1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    VSIBuffer   
   SetIndexBuffer(1,SignBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----       2  1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"VSI");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----    
   int first,bar,timeDiff;
   double Vol;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=1; //      
     }
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      if(VolumeType==VOLUME_TICK) Vol=double(tick_volume[bar]);
      else Vol=double(volume[bar]);

      timeDiff=int(TimeCurrent()-time[bar]);
      if(bar==rates_total-1 && timeDiff>0) VSIBuffer[bar]=Vol/timeDiff;
      else VSIBuffer[bar]=Vol/PSec;

      if(showPerPeriod) VSIBuffer[bar]*=PSec;
      SignBuffer[bar]=XMA.XMASeries(1,prev_calculated,rates_total,XMA_Method,XPhase,XLength,VSIBuffer[bar],bar,false);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
